// Generated by CoffeeScript 1.6.2
var Clip, ClippedBuffer, Collection, DataBindDecor, Factory, TextAttrBinding, attrDecorators;

Collection = require("./collection");

ClippedBuffer = require("../../clip/buffer");

Clip = require("../../clip");

attrDecorators = {
  css: require("./attr/css"),
  show: require("./attr/show"),
  style: require("./attr/style"),
  value: require("./attr/value"),
  click: require("./attr/event"),
  submit: require("./attr/event"),
  mousedown: require("./attr/event"),
  mouseup: require("./attr/event"),
  mouseover: require("./attr/event"),
  mouseout: require("./attr/event"),
  keydown: require("./attr/event"),
  keyup: require("./attr/event"),
  enter: require("./attr/enter"),
  onClick: require("./attr/event"),
  onSubmit: require("./attr/event"),
  onMouseDown: require("./attr/event"),
  onMouseUp: require("./attr/event"),
  onMouseOver: require("./attr/event"),
  onMouseOut: require("./attr/event"),
  onKeyDown: require("./attr/event"),
  onKeyUp: require("./attr/event"),
  onEnter: require("./attr/enter"),
  onChange: require("./attr/change"),
  disable: require("./attr/disable"),
  checked: require("./attr/checked")
};

DataBindDecor = require("./attr/dataBind");

TextAttrBinding = require("./attr/text");

Factory = (function() {
  function Factory() {}

  /*
  */


  Factory.prototype.getDecor = function(node) {
    var ad, attribute, clip, decor, name, _i, _len, _ref;

    decor = new Collection();
    if (node.attributes["data-bind"]) {
      decor.clip = clip = new Clip({
        script: node.attributes["data-bind"][0],
        watch: false
      });
      _ref = clip.scripts.names;
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        name = _ref[_i];
        if (ad = attrDecorators[name]) {
          decor.push(new ad(node, name, clip));
        } else {
          decor.push(new DataBindDecor(node, name, clip));
        }
      }
    }
    for (attribute in node.attributes) {
      decor.push(new TextAttrBinding(node, attribute, new ClippedBuffer(node.attributes[attribute])));
    }
    return decor;
  };

  return Factory;

})();

module.exports = new Factory;
