// Generated by CoffeeScript 1.6.2
var AttributeBinding, Base, ClippedBuffer, NodeBinding, async, attrFactory,
  __hasProp = {}.hasOwnProperty,
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; };

async = require("async");

ClippedBuffer = require("../../clip/buffer");

Base = require("./base");

attrFactory = require("../decor/attrFactory");

AttributeBinding = (function(_super) {
  __extends(AttributeBinding, _super);

  /*
  */


  function AttributeBinding(name, buffer) {
    this.name = name;
    AttributeBinding.__super__.constructor.call(this);
    this.clippedBuffer = new ClippedBuffer(buffer);
  }

  /*
  */


  AttributeBinding.prototype.load = function(info) {
    this.clippedBuffer.reset(info.data);
    if (this.clippedBuffer.text.length) {
      return info.buffer.push(" " + this.name + "=\"" + this.clippedBuffer.text + "\"");
    }
  };

  return AttributeBinding;

})(Base);

NodeBinding = (function(_super) {
  __extends(NodeBinding, _super);

  /*
  */


  NodeBinding.prototype.name = "nodeBinding";

  /*
  */


  function NodeBinding(name, options) {
    this.name = name;
    this.options = options != null ? options : {};
    this.bind = __bind(this.bind, this);
    NodeBinding.__super__.constructor.call(this);
    this.attributes = options.attrs || {};
    this._decor = attrFactory.getDecor(this);
    if (options.children) {
      this.addChild(options.children);
    }
  }

  /*
  */


  NodeBinding.prototype.bind = function() {
    NodeBinding.__super__.bind.call(this);
    this._decor.bind();
    return this;
  };

  /*
  */


  NodeBinding.prototype._writeHead = function(context) {
    this._writeStartBlock(context);
    return context.buffer.push("<" + this.name);
  };

  /*
  */


  NodeBinding.prototype._loadChildren = function(context) {
    this._decor.load(context);
    context.buffer.push(">");
    return NodeBinding.__super__._loadChildren.call(this, context);
  };

  /*
  */


  NodeBinding.prototype._writeTail = function(context) {
    context.buffer.push("</" + this.name + ">");
    return this._writeEndBlock(context);
  };

  /*
  */


  NodeBinding.prototype.clone = function() {
    return new NodeBinding(this.name, this.options);
  };

  return NodeBinding;

})(require("./bindable"));

module.exports = NodeBinding;
